<?php 
use Orhanerday\OpenAi\OpenAi;
/**
 * AI request data  functionality
 */
add_action('wp_ajax_make_ai_call', 'wai_make_ai_call');
function wai_make_ai_call(){
	global $current_user, $wpdb;
	if( check_ajax_referer( 'ajax_call_nonce', 'security') ){
		
		$settings = get_option('wag_options');
 
		$open_ai_key =  $settings['chat_gpt_key']; 
		$temparature =  (int)$settings['chat_gpt_temperature'] / 100; 
		$query = sanitize_text_field( $_POST['query'] );

		$tmp = get_option('tmp1');

		
		$is_error = false;

		if( !$tmp ){
			$open_ai = new OpenAi($open_ai_key);
 
			$complete = $open_ai->chat([
 
				'model' => 'gpt-4',
				'messages' => [
					[
						"role" => "system",
						"content" => "You are a helpful assistant."
					],
					[
						"role" => "user",
						"content" => $query
					],
 
				],
		 
				'temperature' => 0.9,
				'max_tokens' => 3000,
				'frequency_penalty' => 0.5,
				'presence_penalty' => 0,
			]);
		 
			$decoded_response = json_decode( $complete );
			
			/*
			if( $decoded_response )
				$out_text = $decoded_response->choices[0]->text;
			else
				$out_text = false;
			*/

				
				if( $decoded_response ){
					if( isset( $decoded_response->error ) ){
						$out_text = $decoded_response->error->message;
						if( $decoded_response->error->message == '' ){
							$out_text = $decoded_response->error->code;
						}
						$is_error = true;
					}else{
						//$out_text = $decoded_response->choices[0]->text;
						$out_text = $decoded_response->choices[0]->message->content;
					}
		 
				}else{
					$is_error = true;
				}
			
		}else{
			$out_text = $tmp;
		}
		
 
		if( $is_error ){		
			
			echo json_encode( array( 'result' => 'error', 'text' => trim( $out_text ) ) );
		}else{
			echo json_encode( array( 'result' => 'success', 'text' => trim( $out_text ) ) );	
		}
 
		
	}
	die();
}
?>